<template>
  <GI18nCard :i18n="i18n" :card="card" :wiki-entry="wikiEntry">
    <template v-if="value.contact.location" #card-title-append>
      <v-spacer />
      <GDropDownMenu
        i18n="form.addElement"
        :available-elements="availableElements"
        icon="add"
        :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
        @addElement="addElement"
      />
    </template>
    <XmlTextField
      v-model="value.calibrationLaboratoryCode"
      i18n="dcc.administrativeData.calibrationLaboratory.code"
      validate="notEmptyStringType"
    />
    <Contact v-model="value.contact" :card="false" />
    <v-row dense>
      <GCol cols="12" md="4">
        <XmlCheckbox
          v-model="value.cryptElectronicSeal"
          i18n="dcc.administrativeData.calibrationLaboratory.cryptElectronicSeal"
        />
      </GCol>
      <GCol cols="12" md="4">
        <XmlCheckbox
          v-model="value.cryptElectronicSignature"
          i18n="dcc.administrativeData.calibrationLaboratory.cryptElectronicSignature"
        />
      </GCol>
      <GCol cols="12" md="4">
        <XmlCheckbox
          v-model="value.cryptElectronicTimeStamp"
          i18n="dcc.administrativeData.calibrationLaboratory.cryptElectronicTimeStamp"
        />
      </GCol>
    </v-row>
  </GI18nCard>
</template>

<script>
import { RichContentType } from "@d-ptb/dcc-js";
import GI18nCard from "../../App/Common/GI18nCard";
import Contact from "../Common/Contact";
import XmlTextField from "~/components/App/Form/XML/XmlTextField";
import GCol from "~/components/App/Common/GCol";
import XmlCheckbox from "~/components/App/Form/XML/XmlCheckbox";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";
import { insertIf } from "~/assets/util/general";

export default {
  name: "CalibrationLaboratory",
  components: {
    GDropDownMenu,
    XmlCheckbox,
    GCol,
    XmlTextField,
    Contact,
    GI18nCard,
  },
  props: {
    value: Object,
    i18n: {
      type: String,
      default: "dcc.administrativeData.calibrationLaboratory.title",
    },
    card: {
      type: Boolean,
      default: true,
    },
    level: String,
    wikiEntry: String,
  },
  computed: {
    availableElements() {
      return ["further"]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.locationType.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(
          !!this.value.contact.location.further &&
            this.value.contact.location.further[0],
          "further"
        ),
      ];
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "further":
          this.$set(this.value.contact.location, "further", [
            new RichContentType(),
          ]);
      }
    },
  },
};
</script>
